var mainapp;

	// MooTools: the javascript framework.
	// Load this file's selection again by visiting: http://mootools.net/more/112acacca1325d2c134ecfbb648771f1 
	// Or build this file again with packager using: packager build More/Date.Extras More/Hash More/Drag More/Request.JSONP More/Locale
	/*
	---

	script: More.js

	name: More

	description: MooTools More

	license: MIT-style license

	authors:
	  - Guillermo Rauch
	  - Thomas Aylott
	  - Scott Kyle
	  - Arian Stolwijk
	  - Tim Wienk
	  - Christoph Pojer
	  - Aaron Newton

	requires:
	  - Core/MooTools

	provides: [MooTools.More]

	...
	*/

	MooTools.More = {
		'version': '1.3.0.1',
		'build': '6dce99bed2792dffcbbbb4ddc15a1fb9a41994b5'
	};


	/*
	---

	script: Object.Extras.js

	name: Object.Extras

	description: Extra Object generics, like getFromPath which allows a path notation to child elements.

	license: MIT-style license

	authors:
	  - Aaron Newton

	requires:
	  - Core/Object
	  - /MooTools.More

	provides: [Object.Extras]

	...
	*/

	(function(){

	var defined = function(value){
		return value != null;
	};

	Object.extend({

		getFromPath: function(source, key){
			var parts = key.split('.');
			for (var i = 0, l = parts.length; i < l; i++){
				if (source.hasOwnProperty(parts[i])) source = source[parts[i]];
				else return null;
			}
			return source;
		},

		cleanValues: function(object, method){
			method = method || defined;
			for (key in object) if (!method(object[key])){
				delete object[key];
			}
			return object;
		},

		erase: function(object, key){
			if (object.hasOwnProperty(key)) delete object[key];
			return object;
		},

		run: function(object){
			var args = Array.slice(arguments, 1);
			for (key in object) if (object[key].apply){
				object[key].apply(object, args);
			}
			return object;
		}

	});

	})();


	/*
	---

	script: Locale.js

	name: Locale

	description: Provides methods for localization.

	license: MIT-style license

	authors:
	  - Aaron Newton
	  - Arian Stolwijk

	requires:
	  - Core/Events
	  - /Object.Extras
	  - /MooTools.More

	provides: [Locale, Lang]

	...
	*/

	(function(){

	var current = null,
		locales = {},
		inherits = {};

	var getSet = function(set){
		if (instanceOf(set, Locale.Set)) return set;
		else return locales[set];
	};

	var Locale = this.Locale = {

		define: function(locale, set, key, value){
			var name;
			if (instanceOf(locale, Locale.Set)){
				name = locale.name;
				if (name) locales[name] = locale;
			} else {
				name = locale;
				if (!locales[name]) locales[name] = new Locale.Set(name);
				locale = locales[name];
			}

			if (set) locale.define(set, key, value);

			

			if (!current) current = locale;

			return locale;
		},

		use: function(locale){
			locale = getSet(locale);

			if (locale){
				current = locale;

				this.fireEvent('change', locale);

				
			}

			return this;
		},

		getCurrent: function(){
			return current;
		},

		get: function(key, args){
			return (current) ? current.get(key, args) : '';
		},

		inherit: function(locale, inherits, set){
			locale = getSet(locale);

			if (locale) locale.inherit(inherits, set);
			return this;
		},

		list: function(){
			return Object.keys(locales);
		}

	};

	Object.append(Locale, new Events);

	Locale.Set = new Class({

		sets: {},

		inherits: {
			locales: [],
			sets: {}
		},

		initialize: function(name){
			this.name = name || '';
		},

		define: function(set, key, value){
			var defineData = this.sets[set];
			if (!defineData) defineData = {};

			if (key){
				if (typeOf(key) == 'object') defineData = Object.merge(defineData, key);
				else defineData[key] = value;
			}
			this.sets[set] = defineData;

			return this;
		},

		get: function(key, args, _base){
			var value = Object.getFromPath(this.sets, key);
			if (value != null){
				var type = typeOf(value);
				if (type == 'function') value = value.apply(null, Array.from(args));
				else if (type == 'object') value = Object.clone(value);
				return value;
			}

			// get value of inherited locales
			var index = key.indexOf('.'),
				set = index < 0 ? key : key.substr(0, index),
				names = (this.inherits.sets[set] || []).combine(this.inherits.locales).include('en-US');
			if (!_base) _base = [];

			for (var i = 0, l = names.length; i < l; i++){
				if (_base.contains(names[i])) continue;
				_base.include(names[i]);

				var locale = locales[names[i]];
				if (!locale) continue;

				value = locale.get(key, args, _base);
				if (value != null) return value;
			}

			return '';
		},

		inherit: function(names, set){
			names = Array.from(names);

			if (set && !this.inherits.sets[set]) this.inherits.sets[set] = [];

			var l = names.length;
			while (l--) (set ? this.inherits.sets[set] : this.inherits.locales).unshift(names[l]);

			return this;
		}

	});



	})();




	/*
	---

	script: Request.JSONP.js

	name: Request.JSONP

	description: Defines Request.JSONP, a class for cross domain javascript via script injection.

	license: MIT-style license

	authors:
	  - Aaron Newton
	  - Guillermo Rauch
	  - Arian Stolwijk

	requires:
	  - Core/Element
	  - Core/Request

	provides: [Request.JSONP]

	...
	*/

	Request.JSONP = new Class({

		Implements: [Chain, Events, Options],

		options: {
		/*
			onRequest: function(src, scriptElement){},
			onComplete: function(data){},
			onSuccess: function(data){},
			onCancel: function(){},
			onTimeout: function(){},
			onError: function(){}, */
			onRequest: function(src){
				if (this.options.log && window.console && console.log){
					console.log('JSONP retrieving script with url:' + src);
				}
			},
			onError: function(src){
				if (this.options.log && window.console && console.warn){
					console.warn('JSONP '+ src +' will fail in Internet Explorer, which enforces a 2083 bytes length limit on URIs');
				}
			},
			url: '',
			callbackKey: 'callback',
			injectScript: document.head,
			data: '',
			link: 'ignore',
			timeout: 0,
			log: false
		},

		initialize: function(options){
			this.setOptions(options);
		},

		send: function(options){
			if (!Request.prototype.check.call(this, options)) return this;
			this.running = true;

			var type = typeOf(options);
			if (type == 'string' || type == 'element') options = {data: options};
			options = Object.merge(this.options, options || {});

			var data = options.data;
			switch (typeOf(data)){
				case 'element': data = document.id(data).toQueryString(); break;
				case 'object': case 'hash': data = Object.toQueryString(data);
			}

			var index = this.index = Request.JSONP.counter++;

			var src = options.url +
				(options.url.test('\\?') ? '&' :'?') +
				(options.callbackKey) +
				'=Request.JSONP.request_map.request_'+ index +
				(data ? '&' + data : '');

			if (src.length > 2083) this.fireEvent('error', src);

			var script = this.getScript(src).inject(options.injectScript);

			this.fireEvent('request', [script.get('src'), script]);

			Request.JSONP.request_map['request_' + index] = function(){
				this.success(arguments, index);
			}.bind(this);

			if (options.timeout){
				(function(){
					if (this.running) this.fireEvent('timeout', [script.get('src'), script]).fireEvent('failure').cancel();
				}).delay(options.timeout, this);
			}

			return this;
		},

		getScript: function(src){
			return this.script = new Element('script', {
				type: 'text/javascript',
				src: src
			});
		},

		success: function(args, index){
			if (!this.running) return false;
			this.clear()
				.fireEvent('complete', args).fireEvent('success', args)
				.callChain();
		},

		cancel: function(){
			return this.running ? this.clear().fireEvent('cancel') : this;
		},

		isRunning: function(){
			return !!this.running;
		},

		clear: function(){
			if (this.script) this.script.destroy();
			this.running = false;
			return this;
		}

	});

	Request.JSONP.counter = 0;
	Request.JSONP.request_map = {};

	
	
	/*
	Script: MainApp.js
		App Logic.

		License:

		Authors:
			Alfredo Artiles
	*/
	Locale.define('en-US', 'App', {
		error_ie:  'You are using Internet Explorer 6. Please upgrade your browser to increase safety and your browsing experience.</h3> <p>Choose one of the following links to download a modern browser: <p>',
		error_login_twitter: 'Error authenticating with Twitter. The Twitter API seems to be busy now, please try again later.'
	});	
	
	var MainApp = new Class({
		/* initialize */
		initialize: function(options) {
			if (stats) {
				this.showStats();
				this.doPrint.delay(2000);
			}	
		},
		
		doPrint: function() {
			window.print();
		},
		
		showStats: function() {
			var panelEl = new Element('div', {
				'id': 'home_stats',
				'html': 
					'<h2 class="yellow_title">Insights about @' + stats.sourceSName + '</h2>' + 
					'<div class="stats_menu_area">' + 
						'<ul class="stats_menu_column">' + 
							'<li class="stats_bt"><b>Community</b><span id="stat_total">' + stats.stat_total + '</span></li>' +
							'<li class="stats_bt stats_bt_active"><b>Followers</b><span id="stat_followers">' + stats.stat_followers + '</span></li>' +
							'<li class="stats_bt"><b>Friends</b><span id="stat_friends">' + stats.stat_friends + '</span></li>' +
							'<li class="stats_bt"><b>Followers not reciprocated by you</b><span id="stat_youdontfollow">' + stats.stat_youdontfollow + '</span></li>' +
							'<li class="stats_bt"><b>Friends who don\'t reciprocate</b><span id="stat_dontfollowyou">' + stats.stat_dontfollowyou + '</span></li>' +
							'<li class="stats_bt"><b>Reciprocal follow</b><span id="stat_mutual">' + stats.stat_mutual + '</span></li>' + 
						'</ul>' +
					'</div>' +
					'<div id="source_stats">' + 
						'<h3>Insights about <strong>' + stats.title + '</strong></h3>' + 
						'<div class="my_graph" style="width: 700px; height: 300px;"><div id="stat_privacy" class="stat_area" ><span class="stat_progress_box"><img src="img/ajax-loader.gif" width="126" height="22"></span></div><ul id="dstat_privacy" class="my_graph_menu"></ul></div>' + 
						'<div class="my_graph" style="width: 700px; height: 300px; "><div id="stat_verified" class="stat_area" ><span class="stat_progress_box"><img src="img/ajax-loader.gif" width="126" height="22"></span></div><ul id="dstat_verified" class="my_graph_menu"></ul></div>' + 
						'<div  class="my_graph" style="width: 700px; height: 300px;"><div id="stat_avatar" class="stat_area" ><span class="stat_progress_box"><img src="img/ajax-loader.gif" width="126" height="22"></span></div><ul id="dstat_avatar" class="my_graph_menu"></ul></div>' + 
						'<div  class="my_graph" style="width: 700px; height: 300px;"><div id="stat_url" class="stat_area" ><span class="stat_progress_box"><img src="img/ajax-loader.gif" width="126" height="22"></span></div><ul id="dstat_url" class="my_graph_menu"></ul></div>' +
						'<div  class="my_graph" style="width: 700px; height: 250px;"><div id="stat_timezone" class="stat_area" ><span class="stat_progress_box"><img src="img/ajax-loader.gif" width="126" height="22"></span></div><ul id="dstat_timezone" class="my_graph_menu"></ul></div>' +
						'<div  class="my_graph" style="width: 700px; height: 250px;"><div id="stat_lang" class="stat_area" ><span class="stat_progress_box"><img src="img/ajax-loader.gif" width="126" height="22"></span></div><ul id="dstat_lang" class="my_graph_menu"></ul></div>' +
						//'<div  class="my_graph" id="stat_location" style="width: 700px; height: 250px;"></div>' +
						'<div  class="my_graph" style="width: 700px; height: 400px;"><h4>Users by location</h4><div id="stat_map" class="stat_area" ><span class="stat_progress_box"><img src="img/ajax-loader.gif" width="126" height="22"></span></div><ul id="dstat_map" class="my_graph_menu"></ul></ul></div>' +
						'<div  class="my_graph" style="width: 700px; height: 350px;"><span class="stat_progress_box"><div id="stat_followers_range" class="stat_area" ><span class="stat_progress_box"><img src="img/ajax-loader.gif" width="126" height="22"></span></div><ul id="dstat_followers_range" class="my_graph_menu"></ul></div>' +
						'<div  class="my_graph" style="width: 700px; height: 350px;"><span class="stat_progress_box"><div id="stat_friends_range" class="stat_area" ><span class="stat_progress_box"><img src="img/ajax-loader.gif" width="126" height="22"></span></div><ul id="dstat_friends_range" class="my_graph_menu"></ul></div>' +
						'<div  class="my_graph" style="width: 700px; height: 350px;"><span class="stat_progress_box"><div id="stat_ratio_range" class="stat_area" ><span class="stat_progress_box"><img src="img/ajax-loader.gif" width="126" height="22"></span></div><ul id="dstat_ratio_range" class="my_graph_menu"></ul></div>' +
						'<div  class="my_graph" style="width: 700px; height: 350px;"><span class="stat_progress_box"><div id="stat_lasttweet_range" class="stat_area" ><span class="stat_progress_box"><img src="img/ajax-loader.gif" width="126" height="22"></span></div><ul id="dstat_lasttweet_range" class="my_graph_menu"></ul></div>' +
						'<div  class="my_graph" style="width: 700px; height: 350px;"><span class="stat_progress_box"><div id="stat_tweetsperday_range" class="stat_area" ><span class="stat_progress_box"><img src="img/ajax-loader.gif" width="126" height="22"></span></div><ul id="dstat_tweetsperday_range" class="my_graph_menu"></ul></div>' +					
					'</div>'
			});	
			
			
			$('content').grab(panelEl);
			

			this.showPieChart(stats.stat_privacy, 'stat_privacy', 'Profile Privacy', 'privacy', 700, 300, function(data) { this.showChartGrid('dstat_privacy', stats.stat_privacy_total, data); }.bind(this));
			this.showPieChart(stats.stat_verified, 'stat_verified', 'Verified Users', 'verified', 700, 300, function(data) { this.showChartGrid('dstat_verified', stats.stat_verified_total, data); }.bind(this));
			this.showPieChart(stats.stat_avatar, 'stat_avatar', 'Custom or Default Avatar', 'avatar', 700, 300, function(data) { this.showChartGrid('dstat_avatar', stats.stat_avatar_total, data); }.bind(this));
			this.showPieChart(stats.stat_url, 'stat_url', 'Profiles with Web URLs', 'url', 700, 300, function(data) { this.showChartGrid('dstat_url', stats.stat_url_total, data); }.bind(this));
			this.showPieChart(stats.stat_timezone, 'stat_timezone', 'Time Zones', 'timezone', 700, 250, function(data) { this.showChartGrid('dstat_timezone', stats.stat_timezone_total, data); }.bind(this));
			this.showPieChart(stats.stat_lang, 'stat_lang', 'Languages', 'language', 700, 250, function(data) { this.showChartGrid('dstat_lang', stats.stat_lang_total, data); }.bind(this));
			
			this.showMapChart2(stats.stat_map, 'stat_map', 'location', 700, 250, function(data) { this.showChartGrid('dstat_map', null, data); }.bind(this));
			
			this.showBarChart('stat_followers_range', 100, 'Users by Number of Followers', [
				'0 - 50', 
				'50 - 100', 
				'100 - 500', 
				'500 - 1K', 
				'1K - 5K', 
				'5K - 10K', 
				'10K - 50K', 
				'50K - 100K', 
				'>100K'
			], 'Number of Users', 'followers', 'users', stats.stat_followers_range);
			
			
			this.showBarChart('stat_friends_range', 100, 'Users by Number of Friends', [
				'0 - 50', 
				'50 - 100', 
				'100 - 500', 
				'500 - 1K', 
				'1K - 5K', 
				'5K - 10K', 
				'10K - 50K', 
				'>50K'
			], 'Number of Users', 'friends', 'users', stats.stat_friends_range);
			
			this.showBarChart('stat_ratio_range', 265, 'Users by Ratio Followers/Friends', [
				'Many more friends than followers(0 - 0.5)', 
				'More friends than followers(0.5 - 1.0)', 
				'More followers than friends(1.0 - 2.0)', 
				'Many more followers than friends(>2.0)' 
			], 'Number of Users', '', 'users', stats.stat_ratio_range);
			
			this.showBarChart('stat_lasttweet_range', 140, 'Users by Time Since Last Tweet', [
				'Last 24 hours', 
				'Last week', 
				'Last 2 weeks', 
				'Last month', 
				'Last 3 months', 
				'Last 6 months', 
				'Last year', 
				'> 1 year', 
			], 'Number of Users', '', 'users', stats.stat_lasttweet_range);
			
			this.showBarChart('stat_tweetsperday_range', 170,  'Users by Tweets per Day', [
				'< 1 tweet per week', 
				'< 2 tweets per week', 
				'< 5 tweets per day', 
				'< 10 tweets per day', 
				'< 20 tweets per day', 
				'< 50 tweets per day', 
				'> 50 tweets per day'
			], 'Number of Users', '', 'users', stats.stat_tweetsperday_range);
			
		},
		
		showChartGrid: function(elId, total, data) {
			console.log(data);
			var el = $(elId);
			var html = '';
			for (var i = 0; i < data.length && i < 20; i++) {
				html += '<li><span>' + data[i][0] + ': ' + data[i][1] + ((total!=null)?' (' + (data[i][1]/total*100).round(1) + '%)':' ') + '</span></li>';
			}
			el.set('html', html);
		},
		
		showPieChart: function(data, elId, text, serieName, width, height, callback) {
			var chart = new Highcharts.Chart({
				chart: {
					renderTo: elId,
					plotBackgroundColor: null,
					plotBorderWidth: null,
					plotShadow: false,
					width: width,
					height: height
				},
				title: {
					text: text
				},
				tooltip: {
					formatter: function() {
						return '<b>'+ this.point.name +'</b>: '+ this.y +' %';
					}
				},
				plotOptions: {
					pie: {
						allowPointSelect: true,
						cursor: 'pointer',
						dataLabels: {
							enabled: false,
							color: '#000000',
							connectorColor: '#000000',
							formatter: function() {
								return '<b>'+ this.point.name +'</b>: '+ this.y +' %';
							}
						}
					}
				},
				series: [{
					type: 'pie',
					name: serieName,
					data: data
				}]
			});
			if (callback) callback(data);
		},


		
		showBarChart: function(elId, margin, text, categories, yAxisText, tootipText1, tootipText2, data) {		
			console.log(elId, categories, data);
			var chart = new Highcharts.Chart({
				chart: {
					renderTo: elId,
					defaultSeriesType: 'bar',
					margin: [50, 0, 0, margin],
					width: 700 - margin,
					height: 320								
				},
				title: {
					text: text
				},
				legend: {
					enabled: false
				},				
				xAxis: {
					categories: categories,
					title: {
						text: null
					}
				},
				yAxis: {
					min: 0,
					title: {
						text: yAxisText,
						align: 'high'
					}
				},
				tooltip: {
					formatter: function() {
						return '<b>' + this.x +' ' + tootipText1 + '</b><br/>'+
							 Highcharts.numberFormat(this.y, 0) +
							 ' ' + tootipText2;
					}
				},
				plotOptions: {
					bar: {
						dataLabels: {
							enabled: true
						}
					},
					series: {
						minPointLength: 3
					}
				},
				credits: {
					enabled: false
				},
				series: [{
					name: text,
					data: data
				}]
			});
		},
		
		addMarker: function () {
			this.that.geocoder.geocode( {'address': this.location}, function(results, status) {
				if (status == google.maps.GeocoderStatus.OK) {
					if (this.that.firstPoint) {
						this.that.map.setCenter(results[0].geometry.location);
						this.that.firstPoint = false;
					}	
					var marker = new google.maps.Marker({
						map: this.that.map, 
						position: results[0].geometry.location,
						title: this.location + ' (' + this.count + ' users)'
					});
					var infowindow = new google.maps.InfoWindow({
						content: '<h3>' + this.location + '</h3> <p>' + this.count + ' users</p>'
					});
					google.maps.event.addListener(marker, 'click', function() {
						infowindow.open(this.that.map, marker);
					}.bind(this));					
				} else {
					//console.log('failed: ' + this.location + ' (' + this.count + ' users)', results, status);
				}
			}.bind(this));	
		},

		showMapChart2: function(data, elId, field, width, height, callback) {
			var latlng = new google.maps.LatLng(-3.7003454, 40.4166909);
			var myOptions = {
			  zoom: 2,
			  center: latlng,
			  mapTypeId: google.maps.MapTypeId.TERRAIN
			};
			this.map = new google.maps.Map(document.getElementById(elId), myOptions);
			this.geocoder = new google.maps.Geocoder();
			console.log(data);
			this.firstPoint = true;
			for (var i = 0; i < data.length; i++) {
				this.addMarker.delay(1000*i, {location:data[i][0], count:data[i][1], that:this});
			}	
			if (callback) callback(data);
		}
		
	});

window.addEvent('domready', function(){	
	mainapp = new MainApp(); 
});	
